//
//  MotionScript.h
//  iPhoRobo
//
//  Created by Kazu Terasaki on 4/15/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import <Foundation/Foundation.h>
#import "ServoController.h"


#define NUM_SERVOS			9
#define SERVO_MAX			18000
#define SERVO_TORQUE_MAX	1
#define SERVO_DELTA_STEP	20


typedef enum {
	AccelMode_None = 0,
	AccelMode_Immediate,
	AccelMode_Accel,
} ServoAccelModeType;


@interface MotionScript : NSObject {
	
	ServoController *servoController;
	NSMutableArray *motions;
	NSTimer *accelTimer;
	
	UInt16 g_arServo_Center[NUM_SERVOS];
	short g_arServo_Direction[NUM_SERVOS];
	ServoAccelModeType g_arServo_AccelFlag[NUM_SERVOS];
	short g_arServo_Torque[NUM_SERVOS];
	short g_arServo_Target[NUM_SERVOS];
	short g_arServo_Current[NUM_SERVOS];
	short g_arServo_Start[NUM_SERVOS];
	short g_arServo_Delta[NUM_SERVOS];		// Always positive number
	short g_arServo_DeltaPlus[NUM_SERVOS];	// +SERVO_DELTA_STEP or -SERVO_DELTA_STEP
	short g_arServo_Plus[NUM_SERVOS];		// Always positive number
	short g_arServo_Dir[NUM_SERVOS];		// +1 or -1
	short g_arServo_EndPlus[NUM_SERVOS];	// abs(Target - Start)
	short g_arServo_Mid[NUM_SERVOS];		// EndPlus / 2
}

- (void)saveSettings;
- (UInt16)getServoCenterPosition:(NSUInteger)servoID;
- (BOOL)setServoCenterPosition:(UInt16)centerPos servoID:(NSUInteger)servoID;
- (SInt16)getServoPosition:(NSUInteger)servoID;
- (BOOL)setServoPosition:(SInt16)pos servoID:(NSUInteger)servoID;
- (BOOL)setServoTorque:(UInt16)torque servoID:(NSUInteger)servoID;
- (BOOL)setServoAccelMode:(ServoAccelModeType)accelMode servoID:(NSUInteger)servoID;
- (BOOL)capture:(NSUInteger)timePos;

@end

extern MotionScript *gMotionScript;

