//
//  SecondViewController.m
//  iPhoRobo
//
//  Created by Kazu Terasaki on 4/15/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "SecondViewController.h"
#import "MotionScript.h"
#import "RoboEyesViewController.h"


SecondViewController *gSecondViewController;


@implementation SecondViewController

@synthesize motionThread;

/*
 // The designated initializer.  Override if you create the controller programmatically and want to perform customization that is not appropriate for viewDidLoad.
- (id)initWithNibName:(NSString *)nibNameOrNil bundle:(NSBundle *)nibBundleOrNil {
    if (self = [super initWithNibName:nibNameOrNil bundle:nibBundleOrNil]) {
        // Custom initialization
    }
    return self;
}
*/

/*
// Implement loadView to create a view hierarchy programmatically, without using a nib.
- (void)loadView {
}
*/

// Implement viewDidLoad to do additional setup after loading the view, typically from a nib.
- (void)viewDidLoad {
    [super viewDidLoad];
	
	gSecondViewController = self;
}

/*
// Override to allow orientations other than the default portrait orientation.
- (BOOL)shouldAutorotateToInterfaceOrientation:(UIInterfaceOrientation)interfaceOrientation {
    // Return YES for supported orientations
    return (interfaceOrientation == UIInterfaceOrientationPortrait);
}
*/

- (void)didReceiveMemoryWarning {
	// Releases the view if it doesn't have a superview.
    [super didReceiveMemoryWarning];
	
	// Release any cached data, images, etc that aren't in use.
}

- (void)viewDidUnload {
	// Release any retained subviews of the main view.
	// e.g. self.myOutlet = nil;
}


- (void)dealloc {
    [super dealloc];
}


- (void)playbackMotion:(NSUInteger)motionID {
	NSAutoreleasePool *pool = [[NSAutoreleasePool alloc] init];
	
	motionThread = [NSThread currentThread];
	
	do {
		
		// move to initial position
		[gMotionScript setServoTorque:1 servoID:0];
		[gMotionScript setServoTorque:1 servoID:1];
		[gMotionScript setServoTorque:1 servoID:2];
		[gMotionScript setServoTorque:1 servoID:3];
		[gMotionScript setServoAccelMode:AccelMode_Accel servoID:0];
		[gMotionScript setServoAccelMode:AccelMode_Accel servoID:1];
		[gMotionScript setServoAccelMode:AccelMode_Accel servoID:2];
		[gMotionScript setServoAccelMode:AccelMode_Accel servoID:3];
		[gMotionScript setServoPosition:16000-16000 servoID:0];
		[gMotionScript setServoPosition:18000-18000 servoID:1];
		[gMotionScript setServoPosition:-17000+17000 servoID:2];
		[gMotionScript setServoPosition:-17000+17000 servoID:3];
		
		[NSThread sleepForTimeInterval:5];
		if ([[NSThread currentThread] isCancelled]) break;
		
		// wake up
		[gMotionScript setServoPosition:10000-16000 servoID:0];
		[gMotionScript setServoPosition:1000-18000 servoID:1];
		[gMotionScript setServoPosition:-1000+17000 servoID:2];
		[gMotionScript setServoPosition:-11000+17000 servoID:3];
		[NSThread sleepForTimeInterval:3];
		if ([[NSThread currentThread] isCancelled]) break;
		
		for (NSInteger i = 0; i < 10; i++) {
			// right leg forward
			[gMotionScript setServoPosition:12000-16000 servoID:0];
			[gMotionScript setServoPosition:3000-18000 servoID:1];
//			[gMotionScript setServoPosition:1000 servoID:2];
			[gMotionScript setServoPosition:2000+17000 servoID:2];
			[gMotionScript setServoPosition:-9000+17000 servoID:3];
			[NSThread sleepForTimeInterval:0.8];
			if ([[NSThread currentThread] isCancelled]) break;
			
			// left leg forward
			[gMotionScript setServoPosition:8000-16000 servoID:0];
//			[gMotionScript setServoPosition:-1000 servoID:1];
			[gMotionScript setServoPosition:-2000-18000 servoID:1];
			[gMotionScript setServoPosition:-3000+17000 servoID:2];
			[gMotionScript setServoPosition:-13000+17000 servoID:3];
			[NSThread sleepForTimeInterval:0.8];
			if ([[NSThread currentThread] isCancelled]) break;
		}
		if ([[NSThread currentThread] isCancelled]) break;
		
		// wake up
		[gMotionScript setServoPosition:10000-16000 servoID:0];
		[gMotionScript setServoPosition:1000-18000 servoID:1];
		[gMotionScript setServoPosition:-1000+17000 servoID:2];
		[gMotionScript setServoPosition:-11000+17000 servoID:3];
		[NSThread sleepForTimeInterval:3];
		if ([[NSThread currentThread] isCancelled]) break;
		
		// lay down
		[gMotionScript setServoPosition:16000-16000 servoID:0];
		[gMotionScript setServoPosition:18000-18000 servoID:1];
		[gMotionScript setServoPosition:-17000+17000 servoID:2];
		[gMotionScript setServoPosition:-17000+17000 servoID:3];
		[NSThread sleepForTimeInterval:5];
		if ([[NSThread currentThread] isCancelled]) break;
		
		[gMotionScript setServoTorque:0 servoID:0];
		[gMotionScript setServoTorque:0 servoID:1];
		[gMotionScript setServoTorque:0 servoID:2];
		[gMotionScript setServoTorque:0 servoID:3];
		
	} while (NO);
	
	motionThread = nil;
	
	[pool release];
}


- (IBAction)motionButtonPressed:(id)sender {
//	UIButton *button = (UIButton*)sender;
	
	[NSThread detachNewThreadSelector:@selector(playbackMotion:) toTarget:self withObject:nil];
	
	[self presentModalViewController:[[RoboEyesViewController alloc] initWithNibName:@"RoboEyesViewController" bundle:nil] animated:YES];
}


- (IBAction)stopButtonPressed:(id)sender {
	[motionThread cancel];
}


@end
