//
//  ServoController.m
//  soundComm
//
//  Created by Kazu Terasaki on 4/10/10.
//  Copyright 2010 __MyCompanyName__. All rights reserved.
//

#import "ServoController.h"


@implementation ServoController


- (id)init {
	if (self = [super init]) {
		soundComm = [[SoundComm alloc] init];
		for (int i = 0; i < 9; i++) {
			[soundComm setValue:0 forIndex:(i + 1)];		// turn off the servo
			currentPos[i] = 0;
		}
	}
	return self;
}


- (void)dealloc {
	
	[super dealloc];
}


- (BOOL)start {
	[soundComm start];
	return YES;
}


- (BOOL)stop {
	[soundComm stop];
	[soundComm release];
	soundComm = nil;
	return YES;
}


- (BOOL)setServoPosition:(UInt16)pos servoID:(NSUInteger)servoID {
	if (servoID < 9) {
		if ((pos & 0xFF00) == 0xFF00) pos &= 0xFEFF;
		if ((pos & 0x00FF) == 0x00FF) pos &= 0xFFFE;
		currentPos[servoID] = pos;
		UInt16 sum = 0;
		for (NSUInteger i = 0; i < 9; i++) {
			sum += currentPos[i];
		}
		if (((sum & 0xFF00) == 0xFF00) || ((sum & 0x00FF) == 0x00FF)) sum &= 0xFEEF;
		[soundComm setValue:pos forIndex:(servoID + 1)];
		[soundComm setValue:sum forIndex:10];
		return YES;
	}
	return NO;
}


- (UInt16)getServoPosition:(NSUInteger)servoID {
	UInt16 pos = 0;
	if (servoID < 9) {
		pos = currentPos[servoID];
	}
	return pos;
}


@end
